wibble::Iterator< T > Struct Template Reference

`#include <iterator.h>`

Inheritance diagram for wibble::Iterator< T >:
[legend]
Collaboration diagram for wibble::Iterator< T >:
[legend]

## Public Types

typedef Amorph< Iterator< T >, IteratorInterface< T >, 0 > | Super
typedef T | ElementType
Public Types inherited from wibble::Amorph< Iterator< T >, IteratorInterface< T >, 0 >
typedef IteratorInterface< T > | Interface
Public Types inherited from wibble::IteratorMixin< T, Iterator< T > >
typedef T | ElementType
typedef std::forward_iterator_tag | iterator_category
typedef T | value_type
typedef ptrdiff_t | difference_type
typedef T * | pointer
typedef T & | reference
typedef const T & | const_reference

## Public Member Functions

| Iterator (const IteratorInterface< T > &i)
| Iterator ()
bool | operator<= (const Iterator &i) const
T | current () const
virtual void | advance ()
template<typename C >
| operator Iterator< C > ()
Public Member Functions inherited from wibble::Amorph< Iterator< T >, IteratorInterface< T >, 0 >
| Amorph (const MorphInterface< Interface > &b)
| Amorph (const Amorph &a)
| Amorph ()
const Iterator< T > & | self () const
Iterator< T > & | self ()
bool | leq (const Iterator< T > &i) const
bool | operator<= (const Iterator< T > &i) const
void | setInterfacePointer (const Interface *i)
void | setMorphInterfacePointer (const MorphInterface< Interface > *i)
Amorph & | operator= (const Amorph &i)
| ~Amorph ()
Maybe< typename F::result_type > | ifType (F func)
const Interface * | implementation () const
Interface * | implementation ()
MorphInterface< Interface > * | morphInterface () const
const Interface & | wrapped () const
Interface & | wrapped ()
bool | is () const
bool | isVoid () const
T * | impl () const
Public Member Functions inherited from wibble::IteratorMixin< T, Iterator< T > >
Iterator< T > & | self ()
const Iterator< T > & | self () const
IteratorProxy< T > | operator-> () const
Iterator< T > | next () const
T | operator* () const
Iterator< T > & | operator++ ()
Iterator< T > | operator++ (int)
Public Member Functions inherited from wibble::mixin::Comparable< Iterator< T > >
const Iterator< T > & | cmpSelf () const
bool | operator!= (const Iterator< T > &o) const
bool | operator== (const Iterator< T > &o) const
bool | operator< (const Iterator< T > &o) const
bool | operator> (const Iterator< T > &o) const
bool | operator>= (const Iterator< T > &o) const

## Member Typedef Documentation

## ElementType

template<typename T >

typedef T wibble::Iterator< T >::ElementType

## Super

template<typename T >

typedef Amorph< Iterator< T >, IteratorInterface< T >, 0 > wibble::Iterator< T >::Super

## Constructor & Destructor Documentation

## Iterator() [1/2]

template<typename T >

wibble::Iterator< T >::Iterator | ( | const IteratorInterface< T > & | i | ) |

inline

## Iterator() [2/2]

template<typename T >

wibble::Iterator< T >::Iterator | ( |  | ) |

inline

## Member Function Documentation

## advance()

template<typename T >

virtual void wibble::Iterator< T >::advance | ( |  | ) |

inline virtual

## current()

template<typename T >

T wibble::Iterator< T >::current | ( |  | ) | const

inline

## operator Iterator< C >()

template<typename T >
template<typename C >

wibble::Iterator< T >::operator Iterator< C > | ( |  | ) |

## operator<=()

template<typename T >

bool wibble::Iterator< T >::operator<= | ( | const Iterator< T > & | i | ) | const

inline

The documentation for this struct was generated from the following file:

- iterator.h